package solutions.bitbadger.documents.groovy.tests.integration

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test

/**
 * PostgreSQL integration tests for the `Custom` object / `custom*` connection extension functions
 */
@DisplayName('Groovy | PostgreSQL: Custom')
final class PostgreSQLCustomIT {

    @Test
    @DisplayName('list succeeds with empty list')
    void listEmpty() {
        new PgDB().withCloseable CustomFunctions.&listEmpty
    }

    @Test
    @DisplayName('list succeeds with a non-empty list')
    void listAll() {
        new PgDB().withCloseable CustomFunctions.&listAll
    }

    @Test
    @DisplayName('single succeeds when document not found')
    void singleNone() {
        new PgDB().withCloseable CustomFunctions.&singleNone
    }

    @Test
    @DisplayName('single succeeds when a document is found')
    void singleOne() {
        new PgDB().withCloseable CustomFunctions.&singleOne
    }

    @Test
    @DisplayName('nonQuery makes changes')
    void nonQueryChanges() {
        new PgDB().withCloseable CustomFunctions.&nonQueryChanges
    }

    @Test
    @DisplayName('nonQuery makes no changes when where clause matches nothing')
    void nonQueryNoChanges() {
        new PgDB().withCloseable CustomFunctions.&nonQueryNoChanges
    }

    @Test
    @DisplayName('scalar succeeds')
    void scalar() {
        new PgDB().withCloseable CustomFunctions.&scalar
    }
}
